class pg_define : public IClip {  
	VideoInfo vi;
	PVideoFrame frame;

public:
	pg_define(AVSValue args, IScriptEnvironment* env);
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env) { return frame; }
	const VideoInfo& __stdcall GetVideoInfo() { return vi; }
	bool __stdcall GetParity(int n) { return false; }
	void __stdcall GetAudio(void* buf, __int64 start, __int64 count, IScriptEnvironment* env) {
    memset(buf, 0, (size_t)vi.BytesFromAudioSamples(count));
  }
  int __stdcall SetCacheHints(int cachehints,int frame_range) { return 0; }
};

pg_define::pg_define(AVSValue args, IScriptEnvironment* env) {
	int i;

	vi.width=args[0].ArraySize()+HEADERS;
	vi.height=1;
	vi.pixel_type=VideoInfo::CS_BGR32;
	vi.fps_numerator=1;
	vi.fps_denominator=1;
	vi.num_frames=1;
	vi.SetFieldBased(false);
	vi.nchannels=0;

	if (args[0].ArraySize()<6) env->ThrowError("Not enough vertices");
	if (args[0].ArraySize()&1) env->ThrowError("Unpaired coordinate");

	frame=env->NewVideoFrame(vi);

	void* ptr=(void*)frame->GetWritePtr();

	((int*)ptr)[0] = 0x594c4f50; // POLY
	((int*)ptr)[1] = -1; // frame number
	((float*)ptr)[2] = 0; // tension
	((float*)ptr)[3] = 0; // blur
	for (i=0; i<args[0].ArraySize(); i++) {
		((float*)ptr)[i+HEADERS]=(float)args[0][i].AsFloat();
	}
}

AVSValue __cdecl Create_pg_define(AVSValue args, void* user_data, IScriptEnvironment* env) {
	return new pg_define(args, env);
}

AVSValue __cdecl Create_pg_regular(AVSValue args, void* user_data, IScriptEnvironment* env) {
	double ox = args[0].AsFloat();
	double oy = args[1].AsFloat();
	double r = args[2].AsFloat();
	int n = args[3].AsInt();
	double theta = args[4].AsFloat(0)*M_PI*(1.0 / 180.0);

	if (n < 3) env->ThrowError("Not enough vertices");
	double a = M_PI*(2.0 / n);

	AVSValue* q = (AVSValue*)malloc(2*n*sizeof(AVSValue));

	for (int i = 0; i < n; i++) {
		q[i * 2] = AVSValue(ox + sin(theta)*r);
		q[i * 2 + 1] = AVSValue(oy + cos(theta)*r);

		theta += a;
	}

	AVSValue out = AVSValue(q, n * 2);
	AVSValue w = AVSValue(&out, 1);
	return new pg_define(w, env);
}
