class pg_draw : public GenericVideoFilter {
	PClip poly_clip;
	PointF* points;
	ULONG_PTR m_gdiplusToken;
	float tension;
	int nv;

public:
	pg_draw(PClip _child, PClip _clip, IScriptEnvironment* env);
	~pg_draw();
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* ev);
};

pg_draw::pg_draw(PClip _child, PClip _poly_clip, IScriptEnvironment* env):GenericVideoFilter(_child), poly_clip(_poly_clip) {
	float* ptr = (float*)poly_clip->GetFrame(0, env)->GetReadPtr();
	VideoInfo pvi = poly_clip->GetVideoInfo();
	if (!vi.IsRGB32()) env->ThrowError("Input clip must be RGB32");
	if (pvi.height != 1 || ((int*)ptr)[0] != 0x594c4f50) env->ThrowError("Not a polygon");
	nv = (pvi.width - HEADERS) >> 1;
	int p;
	points = new PointF[nv];

	p = HEADERS;
	for (int i = 0; i < nv; i++) {
		points[i].X = (float)(ptr[p++]-0.5);
		points[i].Y = (float)(ptr[p++]-0.5);
	}

	tension = ptr[2];

	GdiplusStartupInput gdiplusStartupInput;
	GdiplusStartup(&m_gdiplusToken, &gdiplusStartupInput, NULL);
}

pg_draw::~pg_draw() {
	GdiplusShutdown(m_gdiplusToken);
}

PVideoFrame __stdcall pg_draw::GetFrame(int n, IScriptEnvironment* env) {
	PVideoFrame polygon = poly_clip->GetFrame(0, env);

	PVideoFrame dst = env->NewVideoFrame(vi);
	unsigned int* dstp = (unsigned int*)dst->GetWritePtr();

	SolidBrush white(Color(255, 255, 255));
	Pen white_pen(Color(255, 255, 255));
	white_pen.SetWidth(16);
	Bitmap* bitmap = new Bitmap(vi.width, vi.height, dst->GetPitch(), PixelFormat32bppRGB, (BYTE*)dstp);
	Graphics *g = Graphics::FromImage(bitmap);

	ImageAttributes *ia = new ImageAttributes();
	ia->SetGamma(2.2);

	g->Clear(Color(0, 0, 0));
	g->SetSmoothingMode(SmoothingModeHighQuality);
//	g->FillPolygon(&white, points, nv);
	g->FillClosedCurve(&white, points, nv, FillModeAlternate, (REAL)tension);
	
//	g->DrawCurve(&white_pen, points, nv, 1);
	/*
	BlurParams myBlurParams;
	myBlurParams.expandEdge = false;
	myBlurParams.radius = 10;
	Blur myBlur;
	myBlur.SetParameters(&myBlurParams);
	bitmap->ApplyEffect(&myBlur, NULL);
*/
	delete bitmap;
	delete g;

	return dst;
}

AVSValue __cdecl Create_pg_draw(AVSValue args, void* user_data, IScriptEnvironment* env) {
	return new pg_draw(args[0].AsClip(), args[1].AsClip(), env);
}
