class pg_transform : public GenericVideoFilter {  
	PVideoFrame frame;

public:
	pg_transform(PClip _child, int t, double x, double y, IScriptEnvironment* env);
	PVideoFrame __stdcall GetFrame(int n, IScriptEnvironment* env) { return frame; }
};

pg_transform::pg_transform(PClip _child, int t, double x, double y, IScriptEnvironment* env):GenericVideoFilter(_child) {
	float* src = (float*)_child->GetFrame(0, env)->GetReadPtr();
	if (vi.height != 1 || ((int*)src)[0] != 0x594c4f50) env->ThrowError("Not a polygon");

	int i;
	int p;
	int nv = (vi.width - HEADERS) >> 1;
	double ox, oy;

	frame = env->NewVideoFrame(vi);
	float* dst = (float*)frame->GetWritePtr();
	memcpy(dst, src, HEADERS << 2);

	if (t > 1) {
		ox = 0; oy = 0;
		p = HEADERS;
		for (i = 0; i < nv; i++) {
			ox += src[p++];
			oy += src[p++];
		}
		ox = ox*(1.0 / nv);
		oy = oy*(1.0 / nv);
	}

	debug("%f,%f", x, y);

	switch (t) {
		case 1: {
			p = HEADERS;
			for (i = 0; i < nv; i++) {
				dst[p] = (float)(src[p]+x); p++;
				dst[p] = (float)(src[p]+y); p++;
			}
		} break;
		case 2: {
			p = HEADERS;
			for (i = 0; i < nv; i++) {
				dst[p] = (float)((src[p] - ox)*x + ox); p++;
				dst[p] = (float)((src[p] - oy)*y + oy); p++;
			}
		} break;
		case 3: {
			p = HEADERS;
			x = -x*M_PI*(1.0 / 180.0);
			for (i = 0; i < nv; i++) {
				dst[p] = (float)(((src[p] - ox)*cos(x) + (src[p + 1] - oy)*-sin(x))+ox); p++;
				dst[p] = (float)(((src[p - 1] - ox)*sin(x) + (src[p] - oy)*cos(x))+oy); p++;
			}
		} break;
	}
}

AVSValue __cdecl Create_pg_transform(AVSValue args, void* user_data, IScriptEnvironment* env) {
	switch ((int)user_data) {
		case 1:					 return new pg_transform(args[0].AsClip(), (int)user_data, args[1].AsFloat(), args[2].AsFloat(), env); break;
		case 2:					 return new pg_transform(args[0].AsClip(), (int)user_data, args[1].AsFloat(), args[2].AsFloat((float)(args[1].AsFloat())), env); break;
		case 3: default: return new pg_transform(args[0].AsClip(), (int)user_data, args[1].AsFloat(), 0, env); break;
	}
}
