/***********************************************************************
"Polygon" - Avisynth polygon drawing using GDI+

Copyright (c) 2015 David Horman

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

The author can be contacted at: david(at)horman(dot)net

Discussion at http://forum.doom9.org/showthread.php?t=?
***********************************************************************/

#include <windows.h>
#define GDIPVER     0x0110  // Use more advanced GDI+ features
#include <gdiplus.h>
#define AVS_LINKAGE_DLLIMPORT
#include <avisynth.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include <stdio.h>

#define HEADERS 4

using namespace Gdiplus;

void debug(const char* a, ...) {
  char string[1024];
	va_list args;

	va_start(args,a);
  vsprintf_s(string,a,args);
	va_end(args);

  OutputDebugString(string);
}

#include "pg_define.cpp"
#include "pg_draw.cpp"
#include "pg_set.cpp"
#include "pg_transform.cpp"
#include "pg_group.cpp"

extern "C" __declspec(dllexport) const char* __stdcall AvisynthPluginInit2(IScriptEnvironment* env) {
	env->AddFunction("pg_define", "f+", Create_pg_define, 0);
	env->AddFunction("pg_draw", "cc", Create_pg_draw, (void*)0);
	env->AddFunction("pg_setFrameNo", "ci", Create_pg_set, (void*)1);
	env->AddFunction("pg_setTension", "cf", Create_pg_set, (void*)2);
	env->AddFunction("pg_setBlur", "cf", Create_pg_set, (void*)3);
	env->AddFunction("pg_regular", "fffi[theta]f", Create_pg_regular, 0);
	env->AddFunction("pg_translate", "cff", Create_pg_transform, (void*)1);
	env->AddFunction("pg_scale", "cf[y]f", Create_pg_transform, (void*)2);
	env->AddFunction("pg_rotate", "cf", Create_pg_transform, (void*)3);
	env->AddFunction("pg_group", "c+", Create_pg_group, 0);
	return "Polygon";
}
